Foxit PDF SDK

Public Types | Public Member Functions | List of all members
foxit.pdf.actions.AdditionalAction Class Reference
Inheritance diagram for foxit.pdf.actions.AdditionalAction:

## Public Types
enum | TriggerEvent { TriggerEvent.e_TriggerPageOpened = 0, TriggerEvent.e_TriggerPageClosed = 1, TriggerEvent.e_TriggerDocWillClose = 2, TriggerEvent.e_TriggerDocWillSave = 3, TriggerEvent.e_TriggerDocSaved = 4, TriggerEvent.e_TriggerDocWillPrint = 5, TriggerEvent.e_TriggerDocPrinted = 6, TriggerEvent.e_TriggerFieldKeyStroke = 7, TriggerEvent.e_TriggerFieldWillFormat = 8, TriggerEvent.e_TriggerFieldValueChanged = 9, TriggerEvent.e_TriggerFieldRecalculateValue = 10, TriggerEvent.e_TriggerAnnotCursorEnter = 11, TriggerEvent.e_TriggerAnnotCursorExit = 12, TriggerEvent.e_TriggerAnnotMouseButtonPressed = 13, TriggerEvent.e_TriggerAnnotMouseButtonReleased = 14, TriggerEvent.e_TriggerAnnotReceiveInputFocus = 15, TriggerEvent.e_TriggerAnnotLoseInputFocus = 16, TriggerEvent.e_TriggerAnnotPageOpened = 17, TriggerEvent.e_TriggerAnnotPageClosed = 18, TriggerEvent.e_TriggerAnnotPageVisible = 19, TriggerEvent.e_TriggerAnnotPageInvisible = 20 }
| Enumeration for trigger event. More...

## Public Member Functions
| AdditionalAction (PDFDoc doc, PDFDictionary pdf_dict)
| Constructor, from a PDF document or a PDF dictionary (if any). More...
| AdditionalAction (PDFPage page)
| Constructor, from a PDF page. More...
| AdditionalAction (Field field)
| Constructor, from a PDF form field. More...
| AdditionalAction (Annot annot)
| Constructor, from a PDF annotation. More...
| AdditionalAction (AdditionalAction other)
| Constructor, with another additional action object. More...
bool | DoJSAction (AdditionalAction.TriggerEvent trigger)
| Perform javascript action which is specified by a trigger event type. More...
Action | GetAction (AdditionalAction.TriggerEvent trigger)
| Get an action with specified trigger event type. More...
PDFDictionary | GetDict ()
| Get the PDF dictionary of current object. More...
bool | IsEmpty ()
| Check whether current object is empty or not. More...
bool | RemoveAction (AdditionalAction.TriggerEvent trigger)
| Remove an action with specified trigger event type. More...
bool | RemoveAllActions ()
| Remove all actions. More...
void | SetAction (AdditionalAction.TriggerEvent trigger, Action action)
| Set a additional-action for specified trigger event type. More...

## Detailed Description

An annotation, page object, or (beginning with PDF 1.3) interactive form field may include an entry named "AA" which specifies an additional-actions dictionary (PDF 1.2) that extends the set of events that can trigger the execution of an action. In PDF 1.4, the document catalog dictionary may also contain an "AA" entry for trigger events affecting the document as a whole.
This class can be constructed from PDF document, PDF page, PDF form field, PDF annotation (only some types) or an existing additional-actions dictionary and can be used to get/set data from an additional-actions dictionary from PDF document, PDF page, PDF form field or PDF annotation.

## Member Enumeration Documentation

## ◆ TriggerEvent

enum foxit.pdf.actions.AdditionalAction.TriggerEvent
| strong

Enumeration for trigger event.

Values of this enumeration should be used alone.

Enumerator
e_TriggerPageOpened | Trigger an action to be performed when the page is opened. This represents "O" entry in a page object's additional-actions dictionary. Only applicable for additional action object constructed from PDF page.
e_TriggerPageClosed | Trigger an action to be performed when the page is closed. This represents "C" entry in a page object's additional-actions dictionary. Only applicable for additional action object constructed from PDF page.
e_TriggerDocWillClose | Trigger a JavaScript action to be performed before closing a document. This represents "WC" entry in a document catalog's additional-actions dictionary. Only applicable for additional action object constructed from PDF document.
e_TriggerDocWillSave | Trigger a JavaScript action to be performed before saving a document. This represents "WS" entry in a document catalog's additional-actions dictionary. Only applicable for additional action object constructed from PDF document.
e_TriggerDocSaved | Trigger a JavaScript action to be performed after saving a document. This represents "DS" entry in a document catalog's additional-actions dictionary. Only applicable for additional action object constructed from PDF document.
e_TriggerDocWillPrint | Trigger a JavaScript action to be performed before printing a document. This represents "WP" entry in a document catalog's additional-actions dictionary. Only applicable for additional action object constructed from PDF document.
e_TriggerDocPrinted | Trigger a JavaScript action to be performed after printing a document. This represents "DP" entry in a document catalog's additional-actions dictionary. Only applicable for additional action object constructed from PDF document.
e_TriggerFieldKeyStroke | Trigger a JavaScript action to be performed when the user types a keystroke into a text field or combo box or modifies the selection in a scrollable list box. This represents "K" entry in a form field's additional-actions dictionary. Only applicable for additional action object constructed from PDF form field. The triggered action can check the keystroke for validity and reject or modify it.
e_TriggerFieldWillFormat | Trigger a JavaScript action to be performed before the field is formatted to display its current value. This represents "F" entry in a form field's additional-actions dictionary. Only applicable for additional action object constructed from PDF form field. The triggered action can modify the field's value before formatting.
e_TriggerFieldValueChanged | Trigger a JavaScript action to be performed when the field's value is changed. This represents "V" entry in a form field's additional-actions dictionary. Only applicable for additional action object constructed from PDF form field. The triggered action can check the new value for validity.
e_TriggerFieldRecalculateValue | Trigger a JavaScript action to be performed to recalculate the value of this field when that of another field changes. This represents "C" entry in a form field's additional-actions dictionary. Only applicable for additional action object constructed from PDF form field. The order in which the document's fields are recalculated can be gotten by function interform.Form.GetFieldsInCalculationOrder .
e_TriggerAnnotCursorEnter | Trigger an action to be performed when the cursor enters the annotation's active area. This represents "E" entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation.
e_TriggerAnnotCursorExit | Trigger an action to be performed when the cursor exits the annotation's active area. This represents "X" entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation.
e_TriggerAnnotMouseButtonPressed | Trigger an action to be performed when the mouse button is pressed inside the annotation's active area. This represents "D" (stands for "Down") entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation.
e_TriggerAnnotMouseButtonReleased | Trigger an action to be performed when the mouse button is released inside the annotation's active area. This represents "U" (stands for "Up") entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation.
e_TriggerAnnotReceiveInputFocus | (Applicable for widget annotation only) Trigger an action to be performed when the annotation receives the input focus. This represents "Fo" entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from a widget annotation.
e_TriggerAnnotLoseInputFocus | (Applicable for widget annotation only) Trigger an action to be performed when the annotation loses the input focus. This represents "Bl" (Uppercase B and lowercase L, which stands for "blurred") entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from a widget annotation.
e_TriggerAnnotPageOpened | Trigger an action to be performed when the page containing the annotation is opened. This represents "PO" entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation. The triggered action is executed after action for foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerPageOpened is triggered and open action of PDF document, if such actions present.
e_TriggerAnnotPageClosed | Trigger an action to be performed when the page containing the annotation is closed. This represents "PC" entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation. The triggered action is executed after action for foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerPageClosed is triggered, if such action present.
e_TriggerAnnotPageVisible | Trigger an action to be performed when the page containing the annotation becomes visible in the viewer application's user interface. This represents "PV" entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation.
e_TriggerAnnotPageInvisible | Trigger an action to be performed when the page containing the annotation is no longer visible in the viewer application's user interface. This represents "PI" entry in an annotation's additional-actions dictionary. Only applicable for additional action object constructed from PDF annotation.

## Constructor & Destructor Documentation

## ◆ AdditionalAction() [1/5]

foxit.pdf.actions.AdditionalAction.AdditionalAction | ( | PDFDoc | doc,
|  | PDFDictionary | pdf_dict
| ) |  |
| inline

Constructor, from a PDF document or a PDF dictionary (if any).

Parameters

  [in] | doc | A valid PDF document object.
  [in] | pdf_dict | A PDF dictionary which represents an additional action dictionary. If this parameter is null, that means just to construct an Additional action object with PDF document. If this parameter is not null, that means to construct an Additional action object from this PDF dictionary should have existed in the specified PDF document and represents the additional action dictionary. Default value: null.

## ◆ AdditionalAction() [2/5]

foxit.pdf.actions.AdditionalAction.AdditionalAction | ( | PDFPage | page | ) |
| inline

Constructor, from a PDF page.

Parameters

  [in] | page | A valid PDF page object.

## ◆ AdditionalAction() [3/5]

foxit.pdf.actions.AdditionalAction.AdditionalAction | ( | Field | field | ) |
| inline

Constructor, from a PDF form field.

Parameters

  [in] | field | A valid PDF form field.

## ◆ AdditionalAction() [4/5]

foxit.pdf.actions.AdditionalAction.AdditionalAction | ( | Annot | annot | ) |
| inline

Constructor, from a PDF annotation.

Parameters

  [in] | annot | A valid PDF annotation. Currently, only support widget and screen annotation. For other types of annotations, this function will throw exception foxit.common.ErrorCode.e_ErrUnsupported .

## ◆ AdditionalAction() [5/5]

foxit.pdf.actions.AdditionalAction.AdditionalAction | ( | AdditionalAction | other | ) |
| inline

Constructor, with another additional action object.

Parameters

  [in] | other | Another additional action object.

## Member Function Documentation

## ◆ DoJSAction()

bool foxit.pdf.actions.AdditionalAction.DoJSAction | ( | AdditionalAction.TriggerEvent | trigger | ) |
| inline

Perform javascript action which is specified by a trigger event type.

If current object is constructed with a valid PDF dictionary, current function will return false directly because Foxit PDF SDK cannot know which kind of object the additional action dictionary is associated with.

Parameters

  [in] | trigger | The input trigger event type. It should be: If current additional-action is constructed from PDF page, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerPageOpened (with same prefix name). If current additional-action is constructed from PDF document, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerDocWillClose (with same prefix name). If current additional-action is constructed from PDF form field, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerFieldKeyStroke (with same prefix name). If current additional-action is constructed from PDF annotation, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerAnnotCursorEnter (with same prefix name).

Returns
  true means success , while false means failure or current object is constructed from PDF dictionary.

## ◆ GetAction()

Action foxit.pdf.actions.AdditionalAction.GetAction | ( | AdditionalAction.TriggerEvent | trigger | ) |
| inline

Get an action with specified trigger event type.

Parameters

  [in] | trigger | The input trigger event type. It should be: If current additional-action is constructed from PDF dictionary, the trigger value can be one of values defined in enum class TriggerEvent. If current additional-action is constructed from PDF page, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerPageOpened (with same prefix name). If current additional-action is constructed from PDF document, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerDocWillClose (with same prefix name). If current additional-action is constructed from PDF form field, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerFieldKeyStroke (with same prefix name). If current additional-action is constructed from PDF annotation, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerAnnotCursorEnter (with same prefix name).

Returns
  An action object.

## ◆ GetDict()

PDFDictionary foxit.pdf.actions.AdditionalAction.GetDict | ( |  | ) |
| inline

Get the PDF dictionary of current object.

Returns
  The PDF dictionary.If there is any error, this function will return null.

## ◆ IsEmpty()

bool foxit.pdf.actions.AdditionalAction.IsEmpty | ( |  | ) |
| inline

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ RemoveAction()

bool foxit.pdf.actions.AdditionalAction.RemoveAction | ( | AdditionalAction.TriggerEvent | trigger | ) |
| inline

Remove an action with specified trigger event type.

If there is no action for input trigger event type when it is valid, this function will return true directly.

Parameters

  [in] | trigger | The input trigger event type. It should be: If current additional-action is constructed from PDF dictionary, the trigger value can be one of values defined in enum class TriggerEvent. If current additional-action is constructed from PDF page, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerPageOpened (with same prefix name). If current additional-action is constructed from PDF document, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerDocWillClose (with same prefix name). If current additional-action is constructed from PDF form field, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerFieldKeyStroke (with same prefix name). If current additional-action is constructed from PDF annotation, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerAnnotCursorEnter (with same prefix name).

Returns
  true means success , while false means failure.

## ◆ RemoveAllActions()

bool foxit.pdf.actions.AdditionalAction.RemoveAllActions | ( |  | ) |
| inline

Remove all actions.

Returns
  true means success , while false means failure.

## ◆ SetAction()

void foxit.pdf.actions.AdditionalAction.SetAction | ( | AdditionalAction.TriggerEvent | trigger,
|  | Action | action
| ) |  |
| inline

Set a additional-action for specified trigger event type.

Parameters

  [in] | trigger | The input trigger event type. It should be: If current additional-action is constructed from PDF dictionary, the trigger value can be one of values defined in enum class TriggerEvent. If current additional-action is constructed from PDF page, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerPageOpened (with same prefix name). If current additional-action is constructed from PDF document, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerDocWillClose (with same prefix name). If current additional-action is constructed from PDF form field, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerFieldKeyStroke (with same prefix name). If current additional-action is constructed from PDF annotation, the trigger value must be one of values starting from foxit.pdf.actions.AdditionalAction.TriggerEvent.e_TriggerAnnotCursorEnter (with same prefix name).
  [in] | action | An action object to be set. If current additional-action is constructed from PDF document or PDF form field, the type of this action should be foxit.pdf.actions.Action.Type.e_TypeJavaScript . If current additional-action is constructed from PDF page, PDF annotation, or PDF dictionary, please refer to comment of the trigger event to check if only specified type of action can be used. Usually, support following types as the new action: foxit.pdf.actions.Action.Type.e_TypeGoto , foxit.pdf.actions.Action.Type.e_TypeURI , foxit.pdf.actions.Action.Type.e_TypeJavaScript , foxit.pdf.actions.Action.Type.e_TypeNamed , foxit.pdf.actions.Action.Type.e_TypeGoToR , foxit.pdf.actions.Action.Type.e_TypeGoToE , foxit.pdf.actions.Action.Type.e_TypeSubmitForm , foxit.pdf.actions.Action.Type.e_TypeResetForm , foxit.pdf.actions.Action.Type.e_TypeHide , foxit.pdf.actions.Action.Type.e_TypeLaunch , foxit.pdf.actions.Action.Type.e_TypeImportData , foxit.pdf.actions.Action.Type.e_TypeRendition .

Returns
  None.